#include <avr/io.h>
#include <avr/interrupt.h>
#include "sw_uart.h"
#include "lcd.h"

void rxCallback(uint8_t data);
char buffer[64];
uint8_t bufferIndex = 0;
volatile uint8_t newLine = 0;

int main(void) {
	initSoftwareUart();
	softwareUartSetCallback(&rxCallback);
	lcdInit();
	sei();
	softwareUartSendString("Elektronika\r\n");
	while (1) {
		if (newLine) {
			newLine = 0;
			lcdString(buffer);
		}
	}
}

void rxCallback(uint8_t data) {
	if (data != '\r') {
		if (bufferIndex < sizeof(buffer)) {
			buffer[bufferIndex++] = data;
		}
	} else {
		buffer[bufferIndex] = 0;
		bufferIndex = 0;
		newLine = 1;
	}
}