#include <avr/io.h>
#include "eeprom.h"

uint8_t eepromReadByteInternal(uint16_t address) {
	//zaczekaj na zakoczenie poprzedniej operacji
	while(EECR & _BV(EEWE));
	//ustaw adres
	EEAR = address;
	//rozpocznij odczyt
	EECR |= _BV(EERE);
	//zwr dan
	return EEDR;
}

void eepromWriteByteInternal(uint16_t address, uint8_t data) {
	//zaczekaj na zakoczenie poprzedniej operacji
	while(EECR & _BV(EEWE));
	//ustaw adres i dan
	EEAR = address;
	EEDR = data;
	//odblokuj zapis
	EECR |= _BV(EEMWE);
	//rozpocznij zapis
	EECR |= _BV(EEWE);
}

void eepromReadBytesInternal(uint16_t address, uint8_t data[], uint16_t size) {
	for (uint16_t i = 0; i < size; i++) {
		data[i] = eepromReadByteInternal(address + i);
	}
}
void eepromWriteBytesInternal(uint16_t address, uint8_t data[], uint16_t size) {
	for (uint16_t i = 0; i < size; i++) {
		eepromWriteByteInternal(address + i, data[i]);
	}
}